#include "forms.h"
#include "xchooser.h"

extern  FD_xchooser *fd_xchooser;  
extern char * lines[1024];
extern int items;

/* callbacks for form xchooser */

void selected(FL_OBJECT *ob, long data)
{
  const char * inputline;
  static char lastchoice[1024];

  inputline = fl_get_browser_line(fd_xchooser->browser,
				  fl_get_browser(fd_xchooser->browser));
  fl_set_input(fd_xchooser->input, inputline );

  if (strcmp( inputline,lastchoice)==0)
    {
      puts(lastchoice);
      exit(0);
    }
  strcpy(lastchoice,inputline);
}

void typed(FL_OBJECT *ob, long data)
{
}

void ok_callback(FL_OBJECT *ob, long data)
{
  const char * inputline;
  inputline=fl_get_input(fd_xchooser->input);
  if (strlen(inputline)==0) return;
  puts(inputline);
  update_file(inputline);
  exit(0);
}

void cancel_callback(FL_OBJECT *ob, long data)
{
  exit(-1);
}

void remove_callback(FL_OBJECT *ob, long data)
{
  int line;
  int i;

  line=fl_get_browser(fd_xchooser->browser);
  free(lines[line-1]);
  for (i=line;i<items;i++)
    {
      lines[i-1]=lines[i];
    }
  items--;
  fl_delete_browser_line(fd_xchooser->browser,line);
  fl_set_input(fd_xchooser->input,"" );
  update_file("");
}
